require 'spec_helper'
describe 'directadmin::resources', :type => :class do
  context 'supported operating systems' do
    on_supported_os.each do |os, facts|
      context "on #{os}" do
        let(:facts) do
          facts
        end

        context "directadmin::resources class without parameters" do
          let(:pre_condition) do
            'class { "::directadmin": clientid => 1234, licenseid => 123456 }'
          end

          case facts[:operatingsystem]
          when 'RedHat', 'CentOS'
            hasstatus = 'true'
          when 'Debian', 'Ubuntu'
            hasstatus = 'false'
          end

          it { is_expected.to compile.with_all_deps }
          it { is_expected.not_to contain_user('admin') }
        end

        context "directadmin::resources class with the admin password specified" do
          let(:pre_condition) do
            'class { "::directadmin": clientid => 1234, licenseid => 123456, admin_password => \'hashed\' }'
          end

          case facts[:operatingsystem]
          when 'RedHat', 'CentOS'
            hasstatus = 'true'
          when 'Debian', 'Ubuntu'
            hasstatus = 'false'
          end

          it { is_expected.to compile.with_all_deps }
          it { is_expected.to contain_user('admin').with_password('hashed') }
        end

      end
    end 
  end
end